var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
const classInlineFlex = "d-inline-flex";
const classCenterGap = "align-items-center gap-1";
const keyBackspace = "Backspace";
function change(target, value) {
  target.value = value;
  target.dispatchEvent(new Event("change"));
}
function shake(newValues, currentValues) {
  return newValues.filter((i) => !currentValues.includes(i));
}
function getOptions(dataset) {
  return {
    separator: dataset.ubTagSeparator || ",",
    variant: dataset.ubTagVariant || "secondary",
    xPosition: dataset.ubTagXPosition || "right",
    transform: dataset.ubTagTransform || "input => input",
    isEnter: dataset.ubTagEnter !== void 0,
    isDuplicate: dataset.ubTagDuplicate !== void 0
  };
}
function noop() {
}
const identity = (x) => x;
function run(fn) {
  return fn();
}
function blank_object() {
  return /* @__PURE__ */ Object.create(null);
}
function run_all(fns) {
  fns.forEach(run);
}
function is_function(thing) {
  return typeof thing === "function";
}
function safe_not_equal(a, b) {
  return a != a ? b == b : a !== b || a && typeof a === "object" || typeof a === "function";
}
function is_empty(obj) {
  return Object.keys(obj).length === 0;
}
const is_client = typeof window !== "undefined";
let now = is_client ? () => window.performance.now() : () => Date.now();
let raf = is_client ? (cb) => requestAnimationFrame(cb) : noop;
const tasks = /* @__PURE__ */ new Set();
function run_tasks(now2) {
  tasks.forEach((task) => {
    if (!task.c(now2)) {
      tasks.delete(task);
      task.f();
    }
  });
  if (tasks.size !== 0)
    raf(run_tasks);
}
function loop(callback) {
  let task;
  if (tasks.size === 0)
    raf(run_tasks);
  return {
    promise: new Promise((fulfill) => {
      tasks.add(task = { c: callback, f: fulfill });
    }),
    abort() {
      tasks.delete(task);
    }
  };
}
function append(target, node) {
  target.appendChild(node);
}
function get_root_for_style(node) {
  if (!node)
    return document;
  const root = node.getRootNode ? node.getRootNode() : node.ownerDocument;
  if (root && /** @type {ShadowRoot} */
  root.host) {
    return (
      /** @type {ShadowRoot} */
      root
    );
  }
  return node.ownerDocument;
}
function append_empty_stylesheet(node) {
  const style_element = element("style");
  style_element.textContent = "/* empty */";
  append_stylesheet(get_root_for_style(node), style_element);
  return style_element.sheet;
}
function append_stylesheet(node, style) {
  append(
    /** @type {Document} */
    node.head || node,
    style
  );
  return style.sheet;
}
function insert(target, node, anchor) {
  target.insertBefore(node, anchor || null);
}
function detach(node) {
  if (node.parentNode) {
    node.parentNode.removeChild(node);
  }
}
function destroy_each(iterations, detaching) {
  for (let i = 0; i < iterations.length; i += 1) {
    if (iterations[i])
      iterations[i].d(detaching);
  }
}
function element(name2) {
  return document.createElement(name2);
}
function text(data) {
  return document.createTextNode(data);
}
function space() {
  return text(" ");
}
function listen(node, event, handler, options) {
  node.addEventListener(event, handler, options);
  return () => node.removeEventListener(event, handler, options);
}
function attr(node, attribute, value) {
  if (value == null)
    node.removeAttribute(attribute);
  else if (node.getAttribute(attribute) !== value)
    node.setAttribute(attribute, value);
}
function children(element2) {
  return Array.from(element2.childNodes);
}
function set_data(text2, data) {
  data = "" + data;
  if (text2.data === data)
    return;
  text2.data = /** @type {string} */
  data;
}
function set_input_value(input, value) {
  input.value = value == null ? "" : value;
}
function set_style(node, key, value, important) {
  if (value == null) {
    node.style.removeProperty(key);
  } else {
    node.style.setProperty(key, value, important ? "important" : "");
  }
}
function toggle_class(element2, name2, toggle) {
  element2.classList.toggle(name2, !!toggle);
}
function custom_event(type, detail, { bubbles = false, cancelable = false } = {}) {
  return new CustomEvent(type, { detail, bubbles, cancelable });
}
const managed_styles = /* @__PURE__ */ new Map();
let active = 0;
function hash(str) {
  let hash2 = 5381;
  let i = str.length;
  while (i--)
    hash2 = (hash2 << 5) - hash2 ^ str.charCodeAt(i);
  return hash2 >>> 0;
}
function create_style_information(doc, node) {
  const info = { stylesheet: append_empty_stylesheet(node), rules: {} };
  managed_styles.set(doc, info);
  return info;
}
function create_rule(node, a, b, duration, delay, ease, fn, uid = 0) {
  const step = 16.666 / duration;
  let keyframes = "{\n";
  for (let p = 0; p <= 1; p += step) {
    const t = a + (b - a) * ease(p);
    keyframes += p * 100 + `%{${fn(t, 1 - t)}}
`;
  }
  const rule = keyframes + `100% {${fn(b, 1 - b)}}
}`;
  const name2 = `__svelte_${hash(rule)}_${uid}`;
  const doc = get_root_for_style(node);
  const { stylesheet, rules } = managed_styles.get(doc) || create_style_information(doc, node);
  if (!rules[name2]) {
    rules[name2] = true;
    stylesheet.insertRule(`@keyframes ${name2} ${rule}`, stylesheet.cssRules.length);
  }
  const animation = node.style.animation || "";
  node.style.animation = `${animation ? `${animation}, ` : ""}${name2} ${duration}ms linear ${delay}ms 1 both`;
  active += 1;
  return name2;
}
function delete_rule(node, name2) {
  const previous = (node.style.animation || "").split(", ");
  const next = previous.filter(
    name2 ? (anim) => anim.indexOf(name2) < 0 : (anim) => anim.indexOf("__svelte") === -1
    // remove all Svelte animations
  );
  const deleted = previous.length - next.length;
  if (deleted) {
    node.style.animation = next.join(", ");
    active -= deleted;
    if (!active)
      clear_rules();
  }
}
function clear_rules() {
  raf(() => {
    if (active)
      return;
    managed_styles.forEach((info) => {
      const { ownerNode } = info.stylesheet;
      if (ownerNode)
        detach(ownerNode);
    });
    managed_styles.clear();
  });
}
let current_component;
function set_current_component(component) {
  current_component = component;
}
function get_current_component() {
  if (!current_component)
    throw new Error("Function called outside component initialization");
  return current_component;
}
function onMount(fn) {
  get_current_component().$$.on_mount.push(fn);
}
const dirty_components = [];
const binding_callbacks = [];
let render_callbacks = [];
const flush_callbacks = [];
const resolved_promise = /* @__PURE__ */ Promise.resolve();
let update_scheduled = false;
function schedule_update() {
  if (!update_scheduled) {
    update_scheduled = true;
    resolved_promise.then(flush);
  }
}
function tick() {
  schedule_update();
  return resolved_promise;
}
function add_render_callback(fn) {
  render_callbacks.push(fn);
}
const seen_callbacks = /* @__PURE__ */ new Set();
let flushidx = 0;
function flush() {
  if (flushidx !== 0) {
    return;
  }
  const saved_component = current_component;
  do {
    try {
      while (flushidx < dirty_components.length) {
        const component = dirty_components[flushidx];
        flushidx++;
        set_current_component(component);
        update(component.$$);
      }
    } catch (e) {
      dirty_components.length = 0;
      flushidx = 0;
      throw e;
    }
    set_current_component(null);
    dirty_components.length = 0;
    flushidx = 0;
    while (binding_callbacks.length)
      binding_callbacks.pop()();
    for (let i = 0; i < render_callbacks.length; i += 1) {
      const callback = render_callbacks[i];
      if (!seen_callbacks.has(callback)) {
        seen_callbacks.add(callback);
        callback();
      }
    }
    render_callbacks.length = 0;
  } while (dirty_components.length);
  while (flush_callbacks.length) {
    flush_callbacks.pop()();
  }
  update_scheduled = false;
  seen_callbacks.clear();
  set_current_component(saved_component);
}
function update($$) {
  if ($$.fragment !== null) {
    $$.update();
    run_all($$.before_update);
    const dirty = $$.dirty;
    $$.dirty = [-1];
    $$.fragment && $$.fragment.p($$.ctx, dirty);
    $$.after_update.forEach(add_render_callback);
  }
}
function flush_render_callbacks(fns) {
  const filtered = [];
  const targets = [];
  render_callbacks.forEach((c) => fns.indexOf(c) === -1 ? filtered.push(c) : targets.push(c));
  targets.forEach((c) => c());
  render_callbacks = filtered;
}
let promise;
function wait() {
  if (!promise) {
    promise = Promise.resolve();
    promise.then(() => {
      promise = null;
    });
  }
  return promise;
}
function dispatch(node, direction, kind) {
  node.dispatchEvent(custom_event(`${direction ? "intro" : "outro"}${kind}`));
}
const outroing = /* @__PURE__ */ new Set();
function transition_in(block, local) {
  if (block && block.i) {
    outroing.delete(block);
    block.i(local);
  }
}
const null_transition = { duration: 0 };
function create_in_transition(node, fn, params) {
  const options = { direction: "in" };
  let config = fn(node, params, options);
  let running = false;
  let animation_name;
  let task;
  let uid = 0;
  function cleanup() {
    if (animation_name)
      delete_rule(node, animation_name);
  }
  function go() {
    const {
      delay = 0,
      duration = 300,
      easing = identity,
      tick: tick2 = noop,
      css
    } = config || null_transition;
    if (css)
      animation_name = create_rule(node, 0, 1, duration, delay, easing, css, uid++);
    tick2(0, 1);
    const start_time = now() + delay;
    const end_time = start_time + duration;
    if (task)
      task.abort();
    running = true;
    add_render_callback(() => dispatch(node, true, "start"));
    task = loop((now2) => {
      if (running) {
        if (now2 >= end_time) {
          tick2(1, 0);
          dispatch(node, true, "end");
          cleanup();
          return running = false;
        }
        if (now2 >= start_time) {
          const t = easing((now2 - start_time) / duration);
          tick2(t, 1 - t);
        }
      }
      return running;
    });
  }
  let started = false;
  return {
    start() {
      if (started)
        return;
      started = true;
      delete_rule(node);
      if (is_function(config)) {
        config = config(options);
        wait().then(go);
      } else {
        go();
      }
    },
    invalidate() {
      started = false;
    },
    end() {
      if (running) {
        cleanup();
        running = false;
      }
    }
  };
}
function ensure_array_like(array_like_or_iterator) {
  return (array_like_or_iterator == null ? void 0 : array_like_or_iterator.length) !== void 0 ? array_like_or_iterator : Array.from(array_like_or_iterator);
}
function mount_component(component, target, anchor) {
  const { fragment, after_update } = component.$$;
  fragment && fragment.m(target, anchor);
  add_render_callback(() => {
    const new_on_destroy = component.$$.on_mount.map(run).filter(is_function);
    if (component.$$.on_destroy) {
      component.$$.on_destroy.push(...new_on_destroy);
    } else {
      run_all(new_on_destroy);
    }
    component.$$.on_mount = [];
  });
  after_update.forEach(add_render_callback);
}
function destroy_component(component, detaching) {
  const $$ = component.$$;
  if ($$.fragment !== null) {
    flush_render_callbacks($$.after_update);
    run_all($$.on_destroy);
    $$.fragment && $$.fragment.d(detaching);
    $$.on_destroy = $$.fragment = null;
    $$.ctx = [];
  }
}
function make_dirty(component, i) {
  if (component.$$.dirty[0] === -1) {
    dirty_components.push(component);
    schedule_update();
    component.$$.dirty.fill(0);
  }
  component.$$.dirty[i / 31 | 0] |= 1 << i % 31;
}
function init(component, options, instance2, create_fragment2, not_equal, props, append_styles, dirty = [-1]) {
  const parent_component = current_component;
  set_current_component(component);
  const $$ = component.$$ = {
    fragment: null,
    ctx: [],
    // state
    props,
    update: noop,
    not_equal,
    bound: blank_object(),
    // lifecycle
    on_mount: [],
    on_destroy: [],
    on_disconnect: [],
    before_update: [],
    after_update: [],
    context: new Map(options.context || (parent_component ? parent_component.$$.context : [])),
    // everything else
    callbacks: blank_object(),
    dirty,
    skip_bound: false,
    root: options.target || parent_component.$$.root
  };
  append_styles && append_styles($$.root);
  let ready = false;
  $$.ctx = instance2 ? instance2(component, options.props || {}, (i, ret, ...rest) => {
    const value = rest.length ? rest[0] : ret;
    if ($$.ctx && not_equal($$.ctx[i], $$.ctx[i] = value)) {
      if (!$$.skip_bound && $$.bound[i])
        $$.bound[i](value);
      if (ready)
        make_dirty(component, i);
    }
    return ret;
  }) : [];
  $$.update();
  ready = true;
  run_all($$.before_update);
  $$.fragment = create_fragment2 ? create_fragment2($$.ctx) : false;
  if (options.target) {
    if (options.hydrate) {
      const nodes = children(options.target);
      $$.fragment && $$.fragment.l(nodes);
      nodes.forEach(detach);
    } else {
      $$.fragment && $$.fragment.c();
    }
    if (options.intro)
      transition_in(component.$$.fragment);
    mount_component(component, options.target, options.anchor);
    flush();
  }
  set_current_component(parent_component);
}
class SvelteComponent {
  constructor() {
    /**
     * ### PRIVATE API
     *
     * Do not use, may change at any time
     *
     * @type {any}
     */
    __publicField(this, "$$");
    /**
     * ### PRIVATE API
     *
     * Do not use, may change at any time
     *
     * @type {any}
     */
    __publicField(this, "$$set");
  }
  /** @returns {void} */
  $destroy() {
    destroy_component(this, 1);
    this.$destroy = noop;
  }
  /**
   * @template {Extract<keyof Events, string>} K
   * @param {K} type
   * @param {((e: Events[K]) => void) | null | undefined} callback
   * @returns {() => void}
   */
  $on(type, callback) {
    if (!is_function(callback)) {
      return noop;
    }
    const callbacks = this.$$.callbacks[type] || (this.$$.callbacks[type] = []);
    callbacks.push(callback);
    return () => {
      const index = callbacks.indexOf(callback);
      if (index !== -1)
        callbacks.splice(index, 1);
    };
  }
  /**
   * @param {Partial<Props>} props
   * @returns {void}
   */
  $set(props) {
    if (this.$$set && !is_empty(props)) {
      this.$$.skip_bound = true;
      this.$$set(props);
      this.$$.skip_bound = false;
    }
  }
}
const PUBLIC_VERSION = "4";
if (typeof window !== "undefined")
  (window.__svelte || (window.__svelte = { v: /* @__PURE__ */ new Set() })).v.add(PUBLIC_VERSION);
function cubicOut(t) {
  const f = t - 1;
  return f * f * f + 1;
}
function slide(node, { delay = 0, duration = 400, easing = cubicOut, axis = "y" } = {}) {
  const style = getComputedStyle(node);
  const opacity = +style.opacity;
  const primary_property = axis === "y" ? "height" : "width";
  const primary_property_value = parseFloat(style[primary_property]);
  const secondary_properties = axis === "y" ? ["top", "bottom"] : ["left", "right"];
  const capitalized_secondary_properties = secondary_properties.map(
    (e) => `${e[0].toUpperCase()}${e.slice(1)}`
  );
  const padding_start_value = parseFloat(style[`padding${capitalized_secondary_properties[0]}`]);
  const padding_end_value = parseFloat(style[`padding${capitalized_secondary_properties[1]}`]);
  const margin_start_value = parseFloat(style[`margin${capitalized_secondary_properties[0]}`]);
  const margin_end_value = parseFloat(style[`margin${capitalized_secondary_properties[1]}`]);
  const border_width_start_value = parseFloat(
    style[`border${capitalized_secondary_properties[0]}Width`]
  );
  const border_width_end_value = parseFloat(
    style[`border${capitalized_secondary_properties[1]}Width`]
  );
  return {
    delay,
    duration,
    easing,
    css: (t) => `overflow: hidden;opacity: ${Math.min(t * 20, 1) * opacity};${primary_property}: ${t * primary_property_value}px;padding-${secondary_properties[0]}: ${t * padding_start_value}px;padding-${secondary_properties[1]}: ${t * padding_end_value}px;margin-${secondary_properties[0]}: ${t * margin_start_value}px;margin-${secondary_properties[1]}: ${t * margin_end_value}px;border-${secondary_properties[0]}-width: ${t * border_width_start_value}px;border-${secondary_properties[1]}-width: ${t * border_width_end_value}px;`
  };
}
function get_each_context(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[6] = list[i];
  child_ctx[39] = i;
  return child_ctx;
}
function create_if_block(ctx) {
  let span;
  let mounted;
  let dispose;
  function click_handler() {
    return (
      /*click_handler*/
      ctx[26](
        /*index*/
        ctx[39]
      )
    );
  }
  return {
    c() {
      span = element("span");
      span.innerHTML = `<svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><line x1="18" y1="6" x2="6" y2="18"></line><line x1="6" y1="6" x2="18" y2="18"></line></svg>`;
      attr(span, "class", classInlineFlex);
      attr(span, "role", "button");
      attr(span, "tabindex", "-1");
    },
    m(target, anchor) {
      insert(target, span, anchor);
      if (!mounted) {
        dispose = [listen(span, "click", click_handler), listen(span, "keydown", void 0)];
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
    },
    d(detaching) {
      if (detaching) {
        detach(span);
      }
      mounted = false;
      run_all(dispose);
    }
  };
}
function create_each_block(ctx) {
  let button;
  let t0_value = (
    /*value*/
    ctx[6] + ""
  );
  let t0;
  let t1;
  let button_class_value;
  let button_intro;
  let mounted;
  let dispose;
  let if_block = !/*disabled*/
  ctx[12] && create_if_block(ctx);
  return {
    c() {
      button = element("button");
      t0 = text(t0_value);
      t1 = space();
      if (if_block)
        if_block.c();
      attr(button, "type", "button");
      attr(button, "class", button_class_value = `${classCenterGap} ${classInlineFlex} py-0 border-0 btn btn-${/*options*/
      ctx[1].variant}`);
      button.disabled = /*disabled*/
      ctx[12];
      attr(
        button,
        "data-index",
        /*index*/
        ctx[39]
      );
      toggle_class(
        button,
        "flex-row-reverse",
        /*left*/
        ctx[15]
      );
      toggle_class(
        button,
        "btn-sm",
        /*sm*/
        ctx[13]
      );
      toggle_class(
        button,
        "btn-lg",
        /*lg*/
        ctx[14]
      );
    },
    m(target, anchor) {
      insert(target, button, anchor);
      append(button, t0);
      append(button, t1);
      if (if_block)
        if_block.m(button, null);
      if (!mounted) {
        dispose = [
          listen(
            button,
            "focus",
            /*handleTagFocus*/
            ctx[17]
          ),
          listen(
            button,
            "blur",
            /*handleTagBlur*/
            ctx[18]
          ),
          listen(
            button,
            "keyup",
            /*handleTagKeyup*/
            ctx[20]
          )
        ];
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*values*/
      16 && t0_value !== (t0_value = /*value*/
      ctx2[6] + ""))
        set_data(t0, t0_value);
      if (!/*disabled*/
      ctx2[12])
        if_block.p(ctx2, dirty);
      if (dirty[0] & /*options*/
      2 && button_class_value !== (button_class_value = `${classCenterGap} ${classInlineFlex} py-0 border-0 btn btn-${/*options*/
      ctx2[1].variant}`)) {
        attr(button, "class", button_class_value);
      }
      if (dirty[0] & /*options, left*/
      32770) {
        toggle_class(
          button,
          "flex-row-reverse",
          /*left*/
          ctx2[15]
        );
      }
      if (dirty[0] & /*options, sm*/
      8194) {
        toggle_class(
          button,
          "btn-sm",
          /*sm*/
          ctx2[13]
        );
      }
      if (dirty[0] & /*options, lg*/
      16386) {
        toggle_class(
          button,
          "btn-lg",
          /*lg*/
          ctx2[14]
        );
      }
    },
    i(local) {
      if (local) {
        if (!button_intro) {
          add_render_callback(() => {
            button_intro = create_in_transition(button, slide, { duration: 150 });
            button_intro.start();
          });
        }
      }
    },
    o: noop,
    d(detaching) {
      if (detaching) {
        detach(button);
      }
      if (if_block)
        if_block.d();
      mounted = false;
      run_all(dispose);
    }
  };
}
function create_fragment(ctx) {
  let div;
  let t;
  let input;
  let div_class_value;
  let mounted;
  let dispose;
  let each_value = ensure_array_like(
    /*values*/
    ctx[4]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block(get_each_context(ctx, each_value, i));
  }
  return {
    c() {
      div = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t = space();
      input = element("input");
      attr(input, "type", "text");
      attr(
        input,
        "placeholder",
        /*placeholder*/
        ctx[5]
      );
      input.disabled = /*disabled*/
      ctx[12];
      set_style(input, "width", `${/*textWidth*/
      ctx[11]}px`);
      attr(div, "class", div_class_value = `${name} d-flex flex-wrap ${classCenterGap} ${/*inputElement*/
      ctx[0].classList.value}`);
      attr(div, "role", "none");
      toggle_class(
        div,
        "disabled",
        /*disabled*/
        ctx[12]
      );
      toggle_class(
        div,
        "focus",
        /*focus*/
        ctx[8]
      );
      toggle_class(
        div,
        "is-valid",
        /*valid*/
        ctx[9]
      );
      toggle_class(
        div,
        "is-invalid",
        /*invalid*/
        ctx[10]
      );
    },
    m(target, anchor) {
      insert(target, div, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div, null);
        }
      }
      append(div, t);
      append(div, input);
      ctx[27](input);
      set_input_value(
        input,
        /*text*/
        ctx[2]
      );
      ctx[31](div);
      if (!mounted) {
        dispose = [
          listen(
            input,
            "input",
            /*input_input_handler*/
            ctx[28]
          ),
          listen(
            input,
            "focus",
            /*focus_handler*/
            ctx[29]
          ),
          listen(
            input,
            "blur",
            /*handleTextElementBlur*/
            ctx[22]
          ),
          listen(
            input,
            "keydown",
            /*handleTextElementKeydown*/
            ctx[23]
          ),
          listen(
            input,
            "input",
            /*input_handler*/
            ctx[30]
          ),
          listen(
            div,
            "click",
            /*handleRootClick*/
            ctx[16]
          ),
          listen(div, "keydown", void 0)
        ];
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*options, disabled, left, sm, lg, handleTagFocus, handleTagBlur, handleTagKeyup, handleRemove, values*/
      2027538) {
        each_value = ensure_array_like(
          /*values*/
          ctx2[4]
        );
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
            transition_in(each_blocks[i], 1);
          } else {
            each_blocks[i] = create_each_block(child_ctx);
            each_blocks[i].c();
            transition_in(each_blocks[i], 1);
            each_blocks[i].m(div, t);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
      if (dirty[0] & /*placeholder*/
      32) {
        attr(
          input,
          "placeholder",
          /*placeholder*/
          ctx2[5]
        );
      }
      if (dirty[0] & /*text*/
      4 && input.value !== /*text*/
      ctx2[2]) {
        set_input_value(
          input,
          /*text*/
          ctx2[2]
        );
      }
      if (dirty[0] & /*textWidth*/
      2048) {
        set_style(input, "width", `${/*textWidth*/
        ctx2[11]}px`);
      }
      if (dirty[0] & /*inputElement*/
      1 && div_class_value !== (div_class_value = `${name} d-flex flex-wrap ${classCenterGap} ${/*inputElement*/
      ctx2[0].classList.value}`)) {
        attr(div, "class", div_class_value);
      }
      if (dirty[0] & /*inputElement, disabled*/
      4097) {
        toggle_class(
          div,
          "disabled",
          /*disabled*/
          ctx2[12]
        );
      }
      if (dirty[0] & /*inputElement, focus*/
      257) {
        toggle_class(
          div,
          "focus",
          /*focus*/
          ctx2[8]
        );
      }
      if (dirty[0] & /*inputElement, valid*/
      513) {
        toggle_class(
          div,
          "is-valid",
          /*valid*/
          ctx2[9]
        );
      }
      if (dirty[0] & /*inputElement, invalid*/
      1025) {
        toggle_class(
          div,
          "is-invalid",
          /*invalid*/
          ctx2[10]
        );
      }
    },
    i(local) {
      for (let i = 0; i < each_value.length; i += 1) {
        transition_in(each_blocks[i]);
      }
    },
    o: noop,
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      destroy_each(each_blocks, detaching);
      ctx[27](null);
      ctx[31](null);
      mounted = false;
      run_all(dispose);
    }
  };
}
const name = "use-bootstrap-tag";
function instance($$self, $$props, $$invalidate) {
  let values;
  let placeholder;
  let { inputElement } = $$props;
  let { options } = $$props;
  const disabled = inputElement.disabled;
  const sm = inputElement.classList.contains("form-control-sm");
  const lg = inputElement.classList.contains("form-control-lg");
  const left = options.xPosition === "left";
  let root;
  let value = "";
  let focus = false;
  let valid = false;
  let invalid = false;
  let text2 = "";
  let textElement;
  let textWidth = 0;
  let textFocus = false;
  let tagActiveIndex = -1;
  inputElement.classList.add(`${name}-target`);
  inputElement.tabIndex = -1;
  onMount(() => {
    setValueFromInputElement();
    inputElement.addEventListener("change", setValueFromInputElement);
    inputElement.addEventListener("focus", () => $$invalidate(24, textFocus = true));
    if (inputElement.form) {
      handleValidation();
    }
  });
  function setValueFromInputElement() {
    $$invalidate(6, value = inputElement.value);
  }
  function toggleValidationClasses() {
    $$invalidate(9, valid = false);
    $$invalidate(10, invalid = false);
    if (inputElement.form.classList.contains("was-validated")) {
      if (inputElement.validity.valid) {
        $$invalidate(9, valid = true);
      } else {
        $$invalidate(10, invalid = true);
      }
    }
  }
  function handleValidation() {
    toggleValidationClasses();
    const observer = new MutationObserver((mutations) => {
      mutations.forEach((mutation) => {
        if (mutation.attributeName === "class") {
          toggleValidationClasses();
        }
      });
    });
    observer.observe(inputElement.form, {
      attributes: true,
      attributeFilter: ["class"]
    });
  }
  function handleRootClick(e) {
    if (e.target.tagName.toLowerCase() !== "button") {
      $$invalidate(24, textFocus = true);
    }
  }
  function handleTagFocus(e) {
    const tag = e.target;
    $$invalidate(8, focus = true);
    tag.classList.add("active");
    $$invalidate(25, tagActiveIndex = +tag.dataset.index);
  }
  function handleTagBlur(e) {
    const tag = e.target;
    $$invalidate(8, focus = false);
    tag.classList.remove("active");
    $$invalidate(25, tagActiveIndex = -1);
  }
  function setValues(values2) {
    change(inputElement, values2.join(options.separator));
    if (inputElement.form) {
      toggleValidationClasses();
    }
  }
  function handleRemove(index) {
    if (index >= 0) {
      setValues(values.filter((_, i) => i !== index));
    }
  }
  async function handleTagKeyup(e) {
    if (e.key === keyBackspace || e.key === "Delete") {
      const index = +e.target.dataset.index;
      handleRemove(index);
      await tick();
      $$invalidate(25, tagActiveIndex = values.length === index ? index - 1 : index);
      if (tagActiveIndex === -1) {
        $$invalidate(24, textFocus = true);
      }
    }
  }
  function handleExists(existingIndex) {
    existingIndex.forEach((index) => {
      const tag = getTagElement(index + 1);
      tag.style.transform = "scale(1.1)";
      setTimeout(
        () => {
          tag.style.transform = "none";
        },
        150
      );
    });
  }
  function appendTag(force = false) {
    const value2 = Function(`return ${options.transform}`)()(text2.trim());
    if (value2 === "") {
      $$invalidate(2, text2 = "");
    }
    if (text2.includes(options.separator) || force && text2 !== "") {
      let newValues = value2.split(options.separator).filter((i) => i.trim() !== "");
      if (newValues.length > 0) {
        if (!options.isDuplicate) {
          const existingIndex = [];
          values.forEach((currentValue, index) => {
            if (newValues.includes(currentValue)) {
              existingIndex.push(index);
            }
          });
          newValues = shake(newValues, values);
          handleExists(existingIndex);
        }
        values.push(...newValues);
        setValues(values);
      }
      $$invalidate(2, text2 = "");
    }
  }
  function handleTextElementBlur() {
    $$invalidate(8, focus = false);
    appendTag(true);
    $$invalidate(24, textFocus = false);
  }
  function handleTextElementKeydown(e) {
    if (text2 === "" && e.key === keyBackspace) {
      handleRemove(values.length - 1);
    }
    if (options.isEnter && text2 !== "" && e.key === "Enter") {
      appendTag(true);
      e.preventDefault();
    }
  }
  function getTagElement(index) {
    return root.querySelector(`button:nth-child(${index})`);
  }
  const click_handler = (index) => handleRemove(index);
  function input_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      textElement = $$value;
      $$invalidate(3, textElement);
    });
  }
  function input_input_handler() {
    text2 = this.value;
    $$invalidate(2, text2);
  }
  const focus_handler = () => $$invalidate(8, focus = true);
  const input_handler = () => appendTag();
  function div_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      root = $$value;
      $$invalidate(7, root);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("inputElement" in $$props2)
      $$invalidate(0, inputElement = $$props2.inputElement);
    if ("options" in $$props2)
      $$invalidate(1, options = $$props2.options);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*value, options*/
    66) {
      $$invalidate(4, values = value.split(options.separator).filter((i) => i !== ""));
    }
    if ($$self.$$.dirty[0] & /*values, inputElement*/
    17) {
      $$invalidate(5, placeholder = values.length ? "" : inputElement.placeholder);
    }
    if ($$self.$$.dirty[0] & /*textElement, text, placeholder*/
    44) {
      if (textElement) {
        const canvas = document.createElement("canvas");
        const context = canvas.getContext("2d");
        if (context) {
          context.font = getComputedStyle(textElement).font;
          $$invalidate(11, textWidth = context.measureText(text2 || placeholder).width);
        }
        canvas.remove();
      }
    }
    if ($$self.$$.dirty[0] & /*textFocus, textElement*/
    16777224) {
      if (textFocus) {
        textElement.focus();
      }
    }
    if ($$self.$$.dirty[0] & /*tagActiveIndex*/
    33554432) {
      if (tagActiveIndex >= 0) {
        getTagElement(tagActiveIndex + 1).focus();
      }
    }
  };
  return [
    inputElement,
    options,
    text2,
    textElement,
    values,
    placeholder,
    value,
    root,
    focus,
    valid,
    invalid,
    textWidth,
    disabled,
    sm,
    lg,
    left,
    handleRootClick,
    handleTagFocus,
    handleTagBlur,
    handleRemove,
    handleTagKeyup,
    appendTag,
    handleTextElementBlur,
    handleTextElementKeydown,
    textFocus,
    tagActiveIndex,
    click_handler,
    input_binding,
    input_input_handler,
    focus_handler,
    input_handler,
    div_binding
  ];
}
class Use_bootstrap_tag extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance, create_fragment, safe_not_equal, { inputElement: 0, options: 1 }, null, [-1, -1]);
  }
}
function UseBootstrapTag(inputElement) {
  const classWrapper = "ub-wrapper";
  const nextElement = inputElement.nextElementSibling;
  if (nextElement && nextElement.classList.contains(classWrapper)) {
    nextElement.remove();
  }
  const target = document.createElement("div");
  target.className = classWrapper;
  inputElement.insertAdjacentElement("afterend", target);
  const options = getOptions(inputElement.dataset);
  new Use_bootstrap_tag({
    target,
    props: {
      options,
      inputElement
    }
  });
  function addValue(value) {
    const currentValues = getValues();
    let newValues = Array.isArray(value) ? value : [value];
    if (!options.isDuplicate) {
      newValues = shake(newValues, currentValues);
    }
    if (newValues.length > 0) {
      currentValues.push(...newValues);
    }
    change(inputElement, currentValues.join(options.separator));
  }
  function removeValue(value) {
    const currentValues = getValues();
    const valueArray = Array.isArray(value) ? value : [value];
    valueArray.forEach((val) => {
      const index = currentValues.indexOf(val);
      if (index !== -1) {
        currentValues.splice(index, 1);
      }
    });
    change(inputElement, currentValues.join(options.separator));
  }
  function getValue() {
    return inputElement.value;
  }
  function getValues() {
    return getValue().split(options.separator);
  }
  return { addValue, removeValue, getValue, getValues };
}
export {
  UseBootstrapTag as default
};
